unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, Grids, About, StdCtrls, ExtCtrls, ComCtrls, QHelp, Stats, IniFiles,
  BPUnit, BPInsert, WWInsert, MMSystem, Names, MultiEnd;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    DrawGrid1: TDrawGrid;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    New1: TMenuItem;
    Options1: TMenuItem;
    Sound1: TMenuItem;
    Bevel1: TBevel;
    TimeLabel: TLabel;
    ImaginesLabel: TLabel;
    ProgBar: TProgressBar;
    Bevel2: TBevel;
    Timer1: TTimer;
    ShotsLabel: TLabel;
    ShowAllCards1: TMenuItem;
    N1: TMenuItem;
    BestPlayers1: TMenuItem;
    N3: TMenuItem;
    Game1: TMenuItem;
    QuickHelp1: TMenuItem;
    N4: TMenuItem;
    Deck1: TMenuItem;
    Blue1: TMenuItem;
    Green1: TMenuItem;
    Red1: TMenuItem;
    Yellow1: TMenuItem;
    ScoreLabel: TLabel;
    Bevel3: TBevel;
    N5: TMenuItem;
    Players1: TMenuItem;
    One1: TMenuItem;
    Two1: TMenuItem;
    Four1: TMenuItem;
    Three1: TMenuItem;
    MultiPanel: TPanel;
    lbPlayer1: TLabel;
    lbPlayer3: TLabel;
    lbPlayer2: TLabel;
    lbPlayer4: TLabel;
    ProgBar1: TProgressBar;
    ProgBar2: TProgressBar;
    ProgBar3: TProgressBar;
    ProgBar4: TProgressBar;
    PausePanel: TPanel;
    Pause1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Sound1Click(Sender: TObject);
    procedure ShowAllCards1Click(Sender: TObject);
    procedure QuickHelp1Click(Sender: TObject);
    procedure Statistics1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Blue1Click(Sender: TObject);
    procedure BestPlayers1Click(Sender: TObject);
    procedure One1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
  private
    { Private declarations }
  public
    Bmp: TBitmap;
    Map: array[0..9,0..4] of Integer;
    Display: array[0..9,0..4] of Boolean;
    ShowCard: array[0..9,0..4] of Boolean;
    FirstShot, Playing, AllCards, InPause: Boolean;
    Image, SelectedDeck: PChar;
  end;

var
  MainForm: TMainForm;
  StGames, StShots, StSeconds, StScore,
  Seconds, Shots, Score, Founds, FSValue,
  Col1, Row1, Col2, Row2, Players, Turn,
  Score1, Score2, Score3, Score4: Integer;
  WinDir: PChar;
  MemoryIni: Text;
  MIni: TIniFile;
  DeckColor, Wow,
  Name1, Name2, Name3, Name4: String;
  TopName, TopScore, TopSeconds, TopShots: Array[1..5] of String;

// ******************************
const TotalCards = 47;
// ******************************

implementation

uses Unit1;

{$R *.DFM}

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
 OM.SHOW
end;

procedure TMainForm.FormCreate(Sender: TObject);
var i: integer;
begin
  // INI file
  GetMem(WinDir, 144);
  GetWindowsDirectory(WinDir, 144);
  StrCat(WinDir, '\Memory.ini');
  if not FileExists(StrPas(WinDir)) then begin
    AssignFile(MemoryIni,WinDir);
    Rewrite(MemoryIni);
    CloseFile(MemoryIni);
  end;
  MIni := TIniFile.Create('Memory.ini');
  with MIni do begin
    // statistics vars
    StGames := StrToInt(ReadString('Statistics','StGames','0'));
    StScore := StrToInt(ReadString('Statistics','StScore','0'));
    StShots := StrToInt(ReadString('Statistics','StShots','0'));
    StSeconds := StrToInt(ReadString('Statistics','StSeconds','0'));
    DeckColor := ReadString('Deck','Current','Blue');
    for i:= 1 to 5 do begin
      TopName[i] := ReadString('Best players','TopName'+IntToStr(i),'Noname');
      TopScore[i] := ReadString('Best players','TopScore'+IntToStr(i),'0');
      TopSeconds[i] := ReadString('Best players','TopSeconds'+IntToStr(i),'0');
      TopShots[i] := ReadString('Best players','TopShots'+IntToStr(i),'0');
    end;
    Wow := ReadString('Best players','Wow','I like Super Memory!');
    Sound1.Checked := ReadBool('Sound','Active',True);
  end;
  FreeMem(WinDir, 144);
  // startup initializations
  Randomize;
  Bmp := TBitmap.Create;
  Players := 1;
  MultiPanel.Hide;
  PausePanel.Hide;
  if DeckColor = 'Green' then Blue1Click(Green1)
  else if DeckColor = 'Blue' then Blue1Click(Blue1)
  else if DeckColor = 'Red' then Blue1Click(Red1)
  else Blue1Click(Yellow1);
  New1Click(Self);
end;

procedure TMainForm.DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if not InPause then begin
  // drawing the correct card...
  if Display[Col, Row] then begin
    if ShowCard[Col, Row] then begin
      Image := PChar('BMP' + IntToStr(Map[Col,Row]));
      Bmp.Handle := LoadBitmap(HInstance, Image);
    end
  // ...or the deck...
    else
    Bmp.Handle := LoadBitmap(HInstance, SelectedDeck);
  end
  // ...or no card.
  else Bmp.Handle := LoadBitmap(HInstance, 'EMPTY');
  end
  else // if InPause
    Bmp.Handle := LoadBitmap(HInstance, SelectedDeck);
  DrawGrid1.Canvas.Draw(Rect.Left, Rect.Top, Bmp);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var i: integer;
begin
  Bmp.Free;
  with MIni do begin
    WriteString('Statistics', 'StGames', IntToStr(StGames));
    WriteString('Statistics', 'StShots', IntToStr(StShots));
    WriteString('Statistics', 'StSeconds', IntToStr(StSeconds));
    WriteString('Statistics', 'StScore', IntToStr(StScore));
    WriteString('Deck','Current', DeckColor);
    for i:= 1 to 5 do begin
      WriteString('Best players','TopName'+IntToStr(i),TopName[i]);
      WriteString('Best players','TopScore'+IntToStr(i),TopScore[i]);
      WriteString('Best players','TopSeconds'+IntToStr(i),TopSeconds[i]);
      WriteString('Best players','TopShots'+IntToStr(i),TopShots[i]);
    end;
    WriteString('Best players','Wow',Wow);
    WriteBool('Sound','Active',Sound1.Checked);
    Free;
  end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  Inc(Seconds);
  if (Seconds<>0) and (Shots<>0) then
  Score := Trunc(400000*Founds/(Seconds*Shots));
  TimeLabel.Caption := 'Seconds: '+IntToStr(Seconds);
  ScoreLabel.Caption := 'Score: '+IntToStr(Score);
end;


procedure TMainForm.DrawGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Col, Row: Integer;

procedure AddToList(AName: String; AScore: Integer);
var i: Integer;
begin
  with MultiEndForm do begin
    if NameList.Items.Count=0 then begin
      NameList.Items.Add(AName);
      ScoreList.Items.Add(IntToStr(AScore));
    end
    else begin
    i := 0;
    while AScore <= StrToInt(ScoreList.Items[i])
     do if (i = NameList.Items.Count-1) then begin
      Inc(i);
      Break;
     end
     else Inc(i);
    NameList.Items.Insert(i,AName);
    ScoreList.Items.Insert(i,IntToStr(AScore));
    end;
  end;
end;

begin
if not InPause then begin
  DrawGrid1.MouseToCell(X, Y, Col, Row);
  // if left button is pressed on an active card
  if (Button = mbLeft) and (Display[Col, Row]) and Playing then begin
    ShowCard[Col, Row] := True;
    // second shot
    if (not FirstShot) and ((Col<>Col1) or (Row<>Row1))then begin
      Playing := False;
      Row2 := Row;
      Col2 := Col;
      FirstShot := True;
      // same cards
      if Map[Col, Row] = FSValue then begin
        // one player
        if Players = 1 then begin
        Inc(Founds);
        ImaginesLabel.Caption := 'Imagines found: '+IntToStr(Founds)+'/25';
        ProgBar.StepIt;
        // end of game
        if Founds = 25 then begin
          Pause1.Enabled := False;
          if Sound1.Checked then PlaySound('Bonus.wav',0,snd_Async);
          Playing := True;
          Inc(Shots);
          ShotsLabel.Caption := 'Total shots: '+IntToStr(Shots);
          Timer1.Enabled := False;
          Score := Trunc(10000000/(Seconds*Shots));
          ScoreLabel.Caption := 'Score: '+IntToStr(Score);
          ShowMessage('End of game!'+#13+'Score: '+IntToStr(Score));
          // statistics
          Inc(StGames);
          StSeconds := StSeconds+Seconds;
          StScore := StScore+Score;
          StShots := StShots+Shots;
          // other instructions...
          Display[Col1, Row1] := False;
          Display[Col2, Row2] := False;
          // input name if score is good
          if Score>StrToInt(TopScore[1]) then WWInsForm.ShowModal
          else if Score>StrToInt(TopScore[5]) then BPInsForm.ShowModal;
          end
          else if Sound1.Checked then PlaySound('Pop1.wav',0,snd_Async);
          end
          // more than one player
          else begin
          case Turn of
            1: begin
                 Inc(Score1);
                 lbPlayer1.Caption := Name1+': '+IntToStr(Score1);
                 ProgBar1.StepIt;
               end;
            2: begin
                 Inc(Score2);
                 lbPlayer2.Caption := Name2+': '+IntToStr(Score2);
                 ProgBar2.StepIt;
               end;
            3: begin
                 Inc(Score3);
                 lbPlayer3.Caption := Name3+': '+IntToStr(Score3);
                 ProgBar3.StepIt;
               end;
            4: begin
                 Inc(Score4);
                 lbPlayer4.Caption := Name4+': '+IntToStr(Score4);
                 ProgBar4.StepIt;
               end;
          end;
          Dec(Turn);
          // if end of game
          if Score1+Score2+Score3+Score4=25 then begin
            Pause1.Enabled := False;
            if Sound1.Checked then PlaySound('Bonus.wav',0,snd_Async);
            Playing := True;
            with MultiEndForm do begin
              NameList.Clear;
              ScoreList.Clear;
            end;
            AddToList(Name1,Score1);
            AddToList(Name2,Score2);
            if Players > 2 then AddToList(Name3,Score3);
            if Players = 4 then AddToList(Name4,Score4);
            MultiEndForm.ShowModal;
            Display[Col1, Row1] := False;
            Display[Col2, Row2] := False;
            DrawGrid1.Repaint;
          end
          else if Sound1.Checked then PlaySound('Pop1.wav',0,snd_Async);
          end;
      end;
    end
    // first shot
    else begin
      FSValue := Map[Col, Row];
      Col1 := Col;
      Row1 := Row;
      FirstShot := False;
    end;
  end
  // if right button is pressed after 2nd shot
  else if (Button = mbRight) and FirstShot
       and (not Playing) and (not AllCards) then begin
    Playing := True;
    if Players = 1 then begin
      Inc(Shots);
      ShotsLabel.Caption := 'Total shots: '+IntToStr(Shots);
    end
    else begin
      Inc(Turn);
      if Turn > Players then Turn := 1;
      lbPlayer1.Color := clBtnFace;
      lbPlayer2.Color := clBtnFace;
      lbPlayer3.Color := clBtnFace;
      lbPlayer4.Color := clBtnFace;
      case Turn of
        1: lbPlayer1.Color := clYellow;
        2: lbPlayer2.Color := clYellow;
        3: lbPlayer3.Color := clYellow;
        4: lbPlayer4.Color := clYellow;
      end;
    end;
    ShowCard[Col1, Row1] := False;
    ShowCard[Col2, Row2] := False;
    if Map[Col1,Row1]=Map[Col2,Row2] then begin
      Display[Col1, Row1] := False;
      Display[Col2, Row2] := False;
    end;
  end;
  DrawGrid1.Repaint;
end;  
end;

procedure TMainForm.Sound1Click(Sender: TObject);
begin
  Sound1.Checked := not Sound1.Checked;
end;

procedure TMainForm.ShowAllCards1Click(Sender: TObject);
var i,j : integer;
begin
  for i := 0 to 9 do
  for j := 0 to 4 do
  ShowCard[i,j] := True;
  Pause1.Enabled := False;
  Timer1.Enabled := False;
  Playing := False;
  AllCards := True;
  DrawGrid1.Repaint;
end;

procedure TMainForm.QuickHelp1Click(Sender: TObject);
begin
  QHelpForm.ShowModal;
end;

procedure TMainForm.Statistics1Click(Sender: TObject);
begin
  StatForm.ShowModal;
end;

procedure TMainForm.New1Click(Sender: TObject);
var i,j,k,num,maxc,r: Integer;
    CanProceed: Boolean;
    a: array [1..25] of Integer;
    c,d: array [1..50] of Integer;
begin
  // various graphic/var settings
  if Players = 1 then begin
    Seconds := 0;
    Shots := 0;
    Founds := 0;
    Score := 0;
    TimeLabel.Caption := 'Seconds: 0';
    ShotsLabel.Caption := 'Total shots: 0';
    ScoreLabel.Caption := 'Score: 0';
    ImaginesLabel.Caption := 'Imagines found: 0/25';
    ProgBar.Position := 0;
    Pause1.Enabled := True;
    Timer1.Enabled := True;
  end
  else begin
    Pause1.Enabled := False;
    Turn := 1;
    Score1 := 0;
    Score2 := 0;
    Score3 := 0;
    Score4 := 0;
    ProgBar1.Position := 0;
    ProgBar2.Position := 0;
    ProgBar3.Position := 0;
    ProgBar4.Position := 0;
    lbPlayer1.Color := clYellow;
    lbPlayer2.Color := clBtnFace;
    lbPlayer3.Color := clBtnFace;
    lbPlayer4.Color := clBtnFace;
    NamesForm.ShowModal;
    lbPlayer1.Caption := Name1+': 0';
    lbPlayer2.Caption := Name2+': 0';
    if Players > 2 then
      lbPlayer3.Caption := Name3+': 0'
    else lbPlayer3.Caption := 'Not playing';
    if Players = 4 then
      lbPlayer4.Caption := Name4+': 0'
    else lbPlayer4.Caption := 'Not playing';
  end;
  FirstShot := True;
  AllCards := False;
  Playing := True;
  Pause1.Checked := False;
  InPause := False;
  PausePanel.Hide;
  for i := 0 to 4 do
  for j := 0 to 9 do begin
    Display[j,i] := True;
    ShowCard[j,i] := False;
  end;
  DrawGrid1.Repaint;
  // creation of array of cards:
  // step 1 - random selection of 25 cards from the total
  for j := 1 to 25 do begin
    repeat
      num := random(TotalCards)+1;
      CanProceed := True;
      for i := 1 to j do
        if a[i]=num then begin
          CanProceed := False;
          Break;
        end;
    until CanProceed;
  a[j] := num;
  end;
  // step 2 - creation of a 50 cards array
  for i := 1 to 25 do begin
    c[i] := a[i];
    c[i+25] := a[i];
  end;
  // step 3 - random sort of the array
  maxc := 50;
  for i := 1 to 50 do begin
    r := random(maxc)+1;
    d[i] := c[r];
    for k := r to (maxc-1)  // moving c[] elements
      do c[k] := c[k+1];
    Dec(maxc);
  end;
  // step 4 - creation of a two-dimension array (Map)
  k := 1;
  for i := 0 to 9 do
    for j := 0 to 4 do begin
      Map[i,j] := d[k];
      Inc(k);
    end;
end;

procedure TMainForm.Blue1Click(Sender: TObject);
begin
  if (Sender as TObject) = Blue1 then begin
    SelectedDeck := 'DECK1';
    DeckColor := 'Blue';
    Blue1.Checked := True;
  end
  else if (Sender as TObject) = Green1 then begin
    SelectedDeck := 'DECK2';
    DeckColor := 'Green';
    Green1.Checked := True;
  end
  else if (Sender as TObject) = Red1 then begin
    SelectedDeck := 'DECK3';
    DeckColor := 'Red';
    Red1.Checked := True;
  end
  else if (Sender as TObject) = Yellow1 then begin
    SelectedDeck := 'DECK4';
    DeckColor := 'Yellow';
    Yellow1.Checked := True;
  end;
  DrawGrid1.Repaint;
end;

procedure TMainForm.BestPlayers1Click(Sender: TObject);
begin
  with BPForm do begin
    o1.Font.Color := clBtnText;
    o2.Font.Color := clBtnText;
    o3.Font.Color := clBtnText;
    o4.Font.Color := clBtnText;
    o5.Font.Color := clBtnText;
    ShowModal;
  end;  
end;

procedure TMainForm.One1Click(Sender: TObject);
begin
if not (Sender as TMenuItem).Checked then 
if MessageDlg('VILL DU STARTA ETT NYTT SPEL',mtConfirmation,[mbYes,mbNo],0)
= mrYes then begin
  (Sender as TMenuItem).Checked := True;
  if (Sender as TMenuItem) = One1 then begin
    MultiPanel.Hide;
    Players := 1;
  end
  else begin
    MultiPanel.Show;
    if (Sender as TMenuItem) = Two1 then Players := 2
    else if (Sender as TMenuItem) = Three1 then Players := 3
    else if (Sender as TMenuItem) = Four1 then Players := 4;
  end;
  New1Click(Self);
end;
end;

procedure TMainForm.Pause1Click(Sender: TObject);
begin
  if Pause1.Checked then begin
  PausePanel.Hide;
  InPause := False;
  Timer1.Enabled := True;
  end
  else begin
  PausePanel.Show;
  InPause := True;
  Timer1.Enabled := False;
  end;
  DrawGrid1.Repaint;
  Pause1.Checked := not Pause1.Checked;
end;

end.
